#!/bin/ksh
# ******************************************************************************************************************************
# * Licensed Materials - Property of IBM                                                                                       *
# * (c) Copyright IBM Corp. 2008, 2009 All Rights Reserved.                                                                    *
# *                                                                                                                            *
# *US Government Users Restricted Rights - Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp*
# ******************************************************************************************************************************

rcrdone(){
echo $MESSAGE.$ACTION:$EXITCODE
echo $CRREWECH002$
exit $EXITCODE
}

validate() {

if [ -z $ORA_VERSION ]
then
	MESSAGE=$CRREWMSGE028
	EXITCODE=$CRREW4528E
	rcrdone
fi

if [ $ORA_VERSION != "1" ]
then
	if [ $ORA_VERSION != "2" ]
	then
		MESSAGE=$CRREWMSGE029
		EXITCODE=$CRREW4529E
		rcrdone
	fi
fi	



if [ -z $ORACLE_HOME ]
then
	MESSAGE=$CRREWMSGE030
	EXITCODE=$CRREW4530E
	rcrdone
fi

if [ ! -d $ORACLE_HOME/bin ]
then
	MESSAGE=$CRREWMSGE031
	EXITCODE=$CRREW4531E
	rcrdone
fi	


if [ -z $ORACLE_BASE ]
then
	MESSAGE=$CRREWMSGE032
	EXITCODE=$CRREW4532E
	rcrdone
fi

if [ ! -d $ORACLE_BASE ]
then
	MESSAGE=$CRREWMSGE032
	EXITCODE=$CRREW4532E
	rcrdone
fi

if [ -z $ORACLE_SID ]
then
	MESSAGE=$CRREWMSGE034
	EXITCODE=$CRREW4534E
	rcrdone
fi

if [ -z $SYSPWD ]
then
	MESSAGE=$CRREWMSGE035
	EXITCODE=$CRREW4535E
	rcrdone
fi

if [ -z $SYSTEMPWD ]
then
	MESSAGE=$CRREWMSGE036
	EXITCODE=$CRREW4536E
	rcrdone
fi

if [ -z $SYSMANPWD ]
then
	MESSAGE=$CRREWMSGE037
	EXITCODE=$CRREW4537E
	rcrdone
fi

if [ -z $DBSNMPWD ]
then
	MESSAGE=$CRREWMSGE038
	EXITCODE=$CRREW4538E
	rcrdone
fi

if [ -z $DBA_USER ]
then
	MESSAGE=$CRREWMSGE039
	EXITCODE=$CRREW4539E
	rcrdone
fi

if [ -z $DBA_PASSWORD ]
then
	MESSAGE=$CRREWMSGE040
	EXITCODE=$CRREW4540E
	rcrdone
fi

if [ -z $DATA_HOME ] 
then
	EXITCODE=$CRREW4508E
	MESSAGE=$CRREWMSGE008
	rcrdone
fi

if [ -z $LANG ]
then
	EXITCODE=$CRREW4585E
	MESSAGE=$CRREWMSGE085
	rcrdone
fi

rcrdone
}


createdb(){

if [ -d $ORACLE_BASE/admin/$ORACLE_SID ]
then
	MESSAGE=$CRREWMSGE053
	EXITCODE=$CRREW4553E
	ACTION=$CRREWECH021
	rcrdone
fi
	
if [ -d $DATA_HOME/oradata/$ORACLE_SID ]
then
	MESSAGE=$CRREWMSGE053
	EXITCODE=$CRREW4553E
	ACTION=$CRREWECH021
	rcrdone
fi

if [ ! -d $DATA_HOME/oradata/$ORACLE_SID ]
then 
	mkdir -p $DATA_HOME/oradata/$ORACLE_SID
	if [ $? -eq 1 ]
	then
		MESSAGE=$CRREWMSGE058
		EXITCODE=$CRREW4558E
		rcrdone
	fi
fi	

if [ ! -d $ORACLE_BASE/admin/$ORACLE_SID/adump ]
then 
	mkdir -p $ORACLE_BASE/admin/$ORACLE_SID/adump
	if [ $? -eq 1 ]
	then
		MESSAGE=$CRREWMSGE059
		EXITCODE=$CRREW4559E
		rcrdone
	fi
fi	

if [ ! -d $ORACLE_BASE/admin/$ORACLE_SID/bdump ]
then 
	mkdir -p $ORACLE_BASE/admin/$ORACLE_SID/bdump
	if [ $? -eq 1 ]
	then
		MESSAGE=$CRREWMSGE060
		EXITCODE=$CRREW4560E
		rcrdone
	fi
fi

if [ ! -d $ORACLE_BASE/admin/$ORACLE_SID/cdump ]
then 
	mkdir -p $ORACLE_BASE/admin/$ORACLE_SID/cdump
	if [ $? -eq 1 ]
	then
		MESSAGE=$CRREWMSGE061
		EXITCODE=$CRREW4561E
		rcrdone
	fi
fi

if [ ! -d $ORACLE_BASE/admin/$ORACLE_SID/dpdump ]
then 
	mkdir -p $ORACLE_BASE/admin/$ORACLE_SID/dpdump
	if [ $? -eq 1 ]
	then
		MESSAGE=$CRREWMSGE062
		EXITCODE=$CRREW4562E
		rcrdone
	fi
fi

if [ ! -d $ORACLE_BASE/admin/$ORACLE_SID/pfile ]
then 
	mkdir -p $ORACLE_BASE/admin/$ORACLE_SID/pfile
	if [ $? -eq 1 ]
	then
		MESSAGE=$CRREWMSGE063
		EXITCODE=$CRREW4563E
		rcrdone
	fi
fi

if [ ! -d $ORACLE_BASE/admin/$ORACLE_SID/udump ]
then 
	mkdir -p $ORACLE_BASE/admin/$ORACLE_SID/udump
	if [ $? -eq 1 ]
	then
		MESSAGE=$CRREWMSGE064
		EXITCODE=$CRREW4564E
		rcrdone
	fi
fi

if [ ! -d $ORACLE_HOME/cfgtoollogs/dbca/$ORACLE_SID ]
then 
	mkdir -p $ORACLE_HOME/cfgtoollogs/dbca/$ORACLE_SID
	if [ $? -eq 1 ]
	then
		MESSAGE=$CRREWMSGE065
		EXITCODE=$CRREW4565E
		rcrdone
	fi
fi

if [ ! -d $ORACLE_HOME/dbs ]
then 
	mkdir -p $ORACLE_HOME/dbs
	if [ $? -eq 1 ]
	then
		MESSAGE=$CRREWMSGE066
		EXITCODE=$CRREW4566E
		rcrdone
	fi
fi

if [ ! -d $ORACLE_BASE/flash_recovery_area ]
then 
	mkdir -p $ORACLE_BASE/flash_recovery_area
	if [ $? -eq 1 ]
	then
		MESSAGE=$CRREWMSGE067
		EXITCODE=$CRREW4567E
		rcrdone
	fi
fi

if [ ! -d $ORACLE_BASE/oradata/$ORACLE_SID ]
then 
	mkdir -p $ORACLE_BASE/oradata/$ORACLE_SID
	if [ $? -eq 1 ]
	then
		MESSAGE=$CRREWMSGE068
		EXITCODE=$CRREW4568E
		rcrdone
	fi
fi

ORALEVEL=`"$ORACLE_HOME"/bin/sqlplus -v|cut -c 19-29`

if [ -z $ORALEVEL ]
then
	MESSAGE=$CRREWMSGE029
	EXITCODE=$CRREWMSGE029
	rcrdone
fi

TORALEVEL=`echo $ORALEVEL| cut -c 1-5`

if [ $TORALEVEL != "11.1." ]
then 
  if [ $TORALEVEL != "11.2." ]
  then 
     if [ $TORALEVEL != "10.2." ]
     then
        if [ $TORALEVEL != "10.3." ]
        then
			MESSAGE=$CRREWMSGE029
			EXITCODE=$CRREWMSGE029
			rcrdone
		fi
	 fi
   fi	 
fi

echo $ORACLE_BASE|sed 's/\//\\\//g'>tmp1.txt                                    

if [ $ORA_VERSION == "1" ]
then
	cat ./createDB/init10.ora |sed -e "s/ORACLE_BASE/`cat tmp1.txt`/g" |sed -e "s/ORACLE_SID/`echo $ORACLE_SID`/g" |sed -e "s/ORALEVEL/`echo $ORALEVEL`/g" > $CD/work_spc/createDB/init$ORACLE_SID.ora
	cat ./createDB/initTemp10.ora |sed -e "s/ORACLE_BASE/`cat tmp1.txt`/g" |sed -e "s/ORACLE_SID/`echo $ORACLE_SID`/g" |sed -e "s/ORALEVEL/`echo $ORALEVEL`/g" > $CD/work_spc/createDB/init$ORACLE_SID\Temp.ora
	if [ $? -eq 1 ]
	then
		MESSAGE=$CRREWMSGE070
		EXITCODE=$CRREW4570E
		rcrdone
	fi
fi	

if [ $ORA_VERSION == "2" ]
then
	cat ./createDB/init.ora |sed -e "s/ORACLE_BASE/`cat tmp1.txt`/g" |sed -e "s/ORACLE_SID/`echo $ORACLE_SID`/g" |sed -e "s/ORALEVEL/`echo $ORALEVEL`/g" > $CD/work_spc/createDB/init$ORACLE_SID.ora
	cat ./createDB/initTemp.ora |sed -e "s/ORACLE_BASE/`cat tmp1.txt`/g" |sed -e "s/ORACLE_SID/`echo $ORACLE_SID`/g" |sed -e "s/ORALEVEL/`echo $ORALEVEL`/g" > $CD/work_spc/createDB/init$ORACLE_SID\Temp.ora
	if [ $? -eq 1 ]
	then
		MESSAGE=$CRREWMSGE071
		EXITCODE=$CRREW4571E
		rcrdone
	fi
fi

rm tmp1.txt
export ORACLE_HOME ORACLE_SID ORACLE_BASE

"$ORACLE_HOME"/bin/sqlplus /nolog @$CD/createDB/createDB.sql $ORACLE_HOME $ORACLE_SID $CD $SYSPWD $SYSTEMPWD $SYSMANPWD $DBSNMPWD $ORACLE_BASE $HOST_NAME $ORA_CMD $ORA_VERSION dbs orapw$ORACLE_SID


}

























chmod -R +x lang

if [ -z $LANG ]
then
	LANG=en
fi	

if [ `echo $LANG | sed 's/\([a-z]*\).*/\1/'` == "en" ]
then 
     LOCALE="en"
	. lang/en/messages.sh
fi	

if [ `echo $LANG | sed 's/\([a-z]*\).*/\1/'` == "it" ]
then 
	LOCALE="it"
	. lang/it/messages.sh
fi	

if [ `echo $LANG | sed 's/\([a-z]*\).*/\1/'` == "pl" ]
then 
	LOCALE="pl"
	. lang/pl/messages.sh
fi	

if [ `echo $LANG | sed 's/\([a-z]*\).*/\1/'` == "ko" ]
then 
	LOCALE="kr"
	. lang/kr/messages.sh
fi

if [ `echo $LANG | sed 's/\([a-z]*\).*/\1/'` == "ja" ]
then 
	LOCALE="ja"
	. lang/ja/messages.sh
fi

if [ `echo $LANG | sed 's/\([a-z]*_[A-Z][A-Z]\).*/\1/'` == "zh_CN" ]
then 
	LOCALE="zh_CN"
	. lang/zh_CN/messages.sh
fi

if [ `echo $LANG | sed 's/\([a-z]*_[A-Z][A-Z]\).*/\1/'` == "zh_TW" ]
then 
	LOCALE="zh_TW"
	. lang/zh_TW/messages.sh
fi

if [ `echo $LANG | sed 's/\([a-z]*\).*/\1/'` == "de" ]
then 
	LOCALE="de"
	SQLVARF="utf8/vars_de.sql"
	. lang/de/messages.sh
fi	

if [ `echo $LANG | sed 's/\([a-z]*\).*/\1/'` == "es" ]
then 
	LOCALE="es"
	SQLVARF="utf8/vars_es.sql"
	. lang/es/messages.sh
fi	

if [ `echo $LANG | sed 's/\([a-z]*\).*/\1/'` == "fr" ]
then 
	LOCALE="fr"
	SQLVARF="utf8/vars_fr.sql"
	. lang/fr/messages.sh
fi

if [ `echo $LANG | sed 's/\([a-z]*_[A-Z][A-Z]\).*/\1/'` == "pt_BR" ]
then 
	LOCALE="pt_BR"
	SQLVARF="utf8/vars_pt_BR.sql"
	. lang/pt_BR/messages.sh
fi


if [ -z $LOCALE ]
then
	 LOCALE="en"
	. lang/en/messages.sh
fi	

SILENT=0
FLAG_SCHEMA=0
MESSAGE="No errors"
ACTION=""
EXITCODE=0

SILENT=0
ORA_CMD="OFF"

if [ $# -eq 1 ]
	then 
	if [ $1 == "-silent" ]
	then
			SILENT=1
	else 
			SILENT=0
	fi
	if [ $1 == "-debug" ]
	then
		ORA_CMD="ON"
		else 
			ORA_CMD="OFF"
	fi
fi

if [ $# -eq 1 ]
	then
	if [ $1 == "-validate" ]
		then
		   validate
	fi
fi

if [ $# -eq 2 ]
then
	if [ $2 -eq "-debug" ]
	 then
			ORA_CMD="ON"
	else 
			ORA_CMD="OFF"
	fi
fi

for i in $*
do
	if [ $i = "-schema" ]
	then
	        FLAG_SCHEMA=1
	else
	 		FLAG_SCHEMA=0
	fi
done

if [ $SILENT -eq 0 ]
then 
	. ./parameters.sh
fi	

if [ -z $ORA_VERSION ]
then
	MESSAGE=$CRREWMSGE028
	EXITCODE=$CRREW4528E
	rcrdone
fi


if [ $ORA_VERSION != "1" ]
then
	if [ $ORA_VERSION != "2" ]
	then
		MESSAGE=$CRREWMSGE029
		EXITCODE=$CRREW4529E
		rcrdone
	fi
fi	

if [ -z $ORACLE_HOME ]
then
	MESSAGE=$CRREWMSGE030
	EXITCODE=$CRREW4530E
	rcrdone
fi

if [ ! -d $ORACLE_HOME/bin ]
then
	MESSAGE=$CRREWMSGE031
	EXITCODE=$CRREW4531E
	rcrdone
fi	

if [ -z $ORACLE_BASE ]
then
	MESSAGE=$CRREWMSGE032
	EXITCODE=$CRREW4532E
	rcrdone
fi

if [ ! -d $ORACLE_BASE ]
then
	MESSAGE=$CRREWMSGE032
	EXITCODE=$CRREW4532E
	rcrdone
fi	

if [ -z $ORACLE_SID ]
then
	MESSAGE=$CRREWMSGE034
	EXITCODE=$CRREW4534E
	rcrdone
fi

if [ $SILENT -eq 0 ]
then 
	echo $CRREWPRMPT016
	read SYSPWD
fi

if [ -z $SYSPWD ]
then
	MESSAGE=$CRREWMSGE035
	EXITCODE=$CRREW4535E
	rcrdone
fi

if [ $SILENT -eq 0 ]
then 
	echo $CRREWPRMPT017
	read SYSTEMPWD
fi

if [ -z $SYSTEMPWD ]
then
	MESSAGE=$CRREWMSGE036
	EXITCODE=$CRREW4536E
	rcrdone
fi

if [ $SILENT -eq 0 ]
then 
	echo $CRREWPRMPT018
	read SYSMANPWD
fi

if [ -z $SYSMANPWD ]
then
	MESSAGE=$CRREWMSGE037
	EXITCODE=$CRREW4537E
	rcrdone
fi

if [ $SILENT -eq 0 ]
then 
	echo $CRREWPRMPT019
	read DBSNMPWD
fi

if [ -z $DBSNMPWD ]
then
	MESSAGE=$CRREWMSGE038
	EXITCODE=$CRREW4538E
	rcrdone
fi

if [ -z $DBA_USER ]
then
	MESSAGE=$CRREWMSGE039
	EXITCODE=$CRREW4539E
	rcrdone
fi

if [ $SILENT -eq 0 ]
then 
	echo $CRREWPRMPT021
	read DBA_PASSWORD
fi

if [ -z $DBA_PASSWORD ]
then
	MESSAGE=$CRREWMSGE040
	EXITCODE=$CRREW4540E
	rcrdone
fi

if [ -z $DATA_HOME ]
then
	MESSAGE=$CRREWMSGE008
	EXITCODE=$CRREW4508E
	rcrdone
fi

HOST_NAME=`hostname`

if [ $SILENT -eq 1 ]
then 
  echo "CONNECT &1/&2" >test.sql
	echo "SELECT COUNT(*) FROM CMCAPACITY;">>test.sql
	echo "EXIT SQL.SQLCODE;">>test.sql
	"$ORACLE_HOME"/bin/sqlplus /nolog  @test.sql $DBA_USER $DBA_PASSWORD
	if [ $? -eq 0 ]
	then
	    rm -f test.sql
		rcrdone
	fi
	rm -f test.sql
fi	

CD=`pwd`

if [ ! -d $CD/logs ]
then
	mkdir -p $CD/logs
else
	rm -dfr $CD/logs
	mkdir -p $CD/logs	
fi
if [ $? -ne 0 ]
then
	MESSAGE=$CRREWMSGE076
	EXITCODE=$CRREW4576E
	rcrdone
fi

if [ ! -d $CD/work_spc ]
then
	mkdir -p $CD/work_spc
else
	rm -dfr $CD/work_spc
	mkdir -p $CD/work_spc
fi	
if [ $? -ne 0 ]
then
	MESSAGE=$CRREWMSGE076
	EXITCODE=$CRREW4576E
	rcrdone
fi

cp -r ./createDB $CD/work_spc
if [ $? -ne 0 ]
then
	MESSAGE=$CRREWMSGE024
	EXITCODE=$CRREW4524E
	rcrdone
fi

if [ $FLAG_SCHEMA -eq 0 ]
then 
	createdb
fi	

echo "ORACLE_HOME:$ORACLE_HOME">>$CD/logs/createDB.log 
echo "ORACLE_BASE:$ORACLE_BASE">>$CD/logs/createDB.log
echo "ORACLE_SID:$ORACLE_SID">>$CD/logs/createDB.log

if [ $FLAG_SCHEMA -eq 1 ]
then 
 CONNST=@$ORACLE_SID
 echo  >./work_spc/ddl/createUsers.sql
 echo  >./work_spc/ddl/tbspace.sql
else 
 CONNST=" "
fi 


"$ORACLE_HOME"/bin/sqlplus /nolog @$CD/buildDW.sql $ORACLE_HOME $ORACLE_SID $CD $SYSPWD $ORACLE_BASE $DBA_USER $DBA_PASSWORD $ORA_CMD $DATA_HOME

"$ORACLE_HOME"/bin/imp USERID=$DBA_USER/$DBA_PASSWORD$CONNST FILE=cognoscs.dmp LOG=logs/importCS.log FROMUSER=RCRCS TOUSER=$DBA_USER
grep -e "ORA" logs/importCS.log>/dev/null
if [ $? -eq 0 ]
then
	MESSAGE=$CRREWMSGE072
	EXITCODE=$CRREW4572E
	rcrdone
fi
rcrdone